﻿; runmode module - gadget handling of the stringfilter app

EnableExplicit

DeclareModule RunMode
Structure GadgetRunMode_Type
  RunMode.i         ; the runmode this gadget belongs to
  GadgetNumber.i
  RequiredFile$
  Flags.i
EndStructure

  #GADGET_IS_CONTAINER = (1 << 0)

  Declare.s GetRequiredFile(GadgetNumber.i)
  Declare.i RegisterGadget(RunMode.i, GadgetNumber.i, Requiredfile$ = "", Flags.i = 0)
  Declare.i UpdateUI(NewRunMode.i)
  EndDeclareModule

Module  RunMode
  
  Global NewList GadgetRunMode.GadgetRunMode_Type()
  
Procedure.s GetRequiredFile(GadgetNumber.i)
  ForEach GadgetRunMode()
    If (GadgetRunMode()\GadgetNumber = GadgetNumber)
      ProcedureReturn GadgetRunMode()\RequiredFile$
    EndIf
  Next
  
  ProcedureReturn ""
EndProcedure

Procedure.i RegisterGadget(RunMode.i, GadgetNumber.i, Requiredfile$ = "", Flags.i = 0)
  
  If (AddElement(GadgetRunMode()) <> 0)
    GadgetRunMode()\GadgetNumber = GadgetNumber
    GadgetRunMode()\RunMode = RunMode
    GadgetRunMode()\RequiredFile$ = Requiredfile$
    GadgetRunMode()\Flags = Flags
    
    ProcedureReturn 1
  Else
    ProcedureReturn -1
  EndIf
  
EndProcedure

Procedure.i UpdateUI(NewRunMode.i)
  Define.i DisplayedGadgets
  
  DisplayedGadgets = 0
  ForEach GadgetRunMode()
    If (GadgetRunMode()\RunMode = NewRunMode)
      If ((GadgetRunMode()\RequiredFile$ = "") Or (FileSize(GadgetRunMode()\RequiredFile$) >= 0))
        DisplayedGadgets + 1
        DisableGadget(GadgetRunMode()\GadgetNumber, #False)
        HideGadget(GadgetRunMode()\GadgetNumber, #False)
      Else
        DisableGadget(GadgetRunMode()\GadgetNumber, #True)
        HideGadget(GadgetRunMode()\GadgetNumber, #True)
      EndIf
    Else
      DisableGadget(GadgetRunMode()\GadgetNumber, #True)
      HideGadget(GadgetRunMode()\GadgetNumber, #True)
    EndIf
  Next
  
  ProcedureReturn DisplayedGadgets
EndProcedure

EndModule

; IDE Options = PureBasic 6.00 LTS (Windows - x64)
; CursorPosition = 48
; FirstLine = 15
; Folding = -
; EnableThread
; EnableXP
; DPIAware
; CompileSourceDirectory
; Compiler = PureBasic 6.00 LTS (Windows - x64)